# OpenEXR.jl

[![Build Status](https://github.com/twadleigh/OpenEXR.jl/workflows/CI/badge.svg)](https://github.com/twadleigh/OpenEXR.jl/actions?query=workflow%3A%22CI%22+branch%3Amaster)
[![codecov.io](http://codecov.io/github/twadleigh/OpenEXR.jl/coverage.svg?branch=master)](http://codecov.io/github/twadleigh/OpenEXR.jl?branch=master)

Saving and loading of OpenEXR files.

# Load an EXR file

```jl
using OpenEXR

myimage = OpenEXR.load("myimage.exr")
```

`myimage` has type `Array{T,2}` where `T` is one of:

- RGBA{Float16}
- RGB{Float16}
- GrayA{Float16}
- Gray{Float16}

depending on which channels are present in the file.

# Save an image as an EXR file

```jl
OpenEXR.save("myimage2.exr", myimage)
```

`myimage` can be any subtype of `AbstractArray{C,2}` where `C` is any color type defined in
[ColorTypes.jl](https://github.com/JuliaGraphics/ColorTypes.jl).

# Julia wrapper for header: ImfCRgbaFile.h
# Automatically generated using Clang.jl


function ImfFloatToHalf(f, h)
    ccall((:ImfFloatToHalf, libOpenEXR), Cvoid, (Cfloat, Ptr{ImfHalf}), f, h)
end

function ImfFloatToHalfArray(n, f, h)
    ccall((:ImfFloatToHalfArray, libOpenEXR), Cvoid, (Cint, Ptr{Cfloat}, Ptr{ImfHalf}), n, f, h)
end

function ImfHalfToFloat(h)
    ccall((:ImfHalfToFloat, libOpenEXR), Cfloat, (ImfHalf,), h)
end

function ImfHalfToFloatArray(n, h, f)
    ccall((:ImfHalfToFloatArray, libOpenEXR), Cvoid, (Cint, Ptr{ImfHalf}, Ptr{Cfloat}), n, h, f)
end

function ImfNewHeader()
    ccall((:ImfNewHeader, libOpenEXR), Ptr{ImfHeader}, ())
end

function ImfDeleteHeader(hdr)
    ccall((:ImfDeleteHeader, libOpenEXR), Cvoid, (Ptr{ImfHeader},), hdr)
end

function ImfCopyHeader(hdr)
    ccall((:ImfCopyHeader, libOpenEXR), Ptr{ImfHeader}, (Ptr{ImfHeader},), hdr)
end

function ImfHeaderSetDisplayWindow(hdr, xMin, yMin, xMax, yMax)
    ccall((:ImfHeaderSetDisplayWindow, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Cint, Cint, Cint, Cint), hdr, xMin, yMin, xMax, yMax)
end

function ImfHeaderDisplayWindow(hdr, xMin, yMin, xMax, yMax)
    ccall((:ImfHeaderDisplayWindow, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}), hdr, xMin, yMin, xMax, yMax)
end

function ImfHeaderSetDataWindow(hdr, xMin, yMin, xMax, yMax)
    ccall((:ImfHeaderSetDataWindow, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Cint, Cint, Cint, Cint), hdr, xMin, yMin, xMax, yMax)
end

function ImfHeaderDataWindow(hdr, xMin, yMin, xMax, yMax)
    ccall((:ImfHeaderDataWindow, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}), hdr, xMin, yMin, xMax, yMax)
end

function ImfHeaderSetPixelAspectRatio(hdr, pixelAspectRatio)
    ccall((:ImfHeaderSetPixelAspectRatio, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Cfloat), hdr, pixelAspectRatio)
end

function ImfHeaderPixelAspectRatio(hdr)
    ccall((:ImfHeaderPixelAspectRatio, libOpenEXR), Cfloat, (Ptr{ImfHeader},), hdr)
end

function ImfHeaderSetScreenWindowCenter(hdr, x, y)
    ccall((:ImfHeaderSetScreenWindowCenter, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Cfloat, Cfloat), hdr, x, y)
end

function ImfHeaderScreenWindowCenter(hdr, x, y)
    ccall((:ImfHeaderScreenWindowCenter, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Ptr{Cfloat}, Ptr{Cfloat}), hdr, x, y)
end

function ImfHeaderSetScreenWindowWidth(hdr, width)
    ccall((:ImfHeaderSetScreenWindowWidth, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Cfloat), hdr, width)
end

function ImfHeaderScreenWindowWidth(hdr)
    ccall((:ImfHeaderScreenWindowWidth, libOpenEXR), Cfloat, (Ptr{ImfHeader},), hdr)
end

function ImfHeaderSetLineOrder(hdr, lineOrder)
    ccall((:ImfHeaderSetLineOrder, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Cint), hdr, lineOrder)
end

function ImfHeaderLineOrder(hdr)
    ccall((:ImfHeaderLineOrder, libOpenEXR), Cint, (Ptr{ImfHeader},), hdr)
end

function ImfHeaderSetCompression(hdr, compression)
    ccall((:ImfHeaderSetCompression, libOpenEXR), Cvoid, (Ptr{ImfHeader}, Cint), hdr, compression)
end

function ImfHeaderCompression(hdr)
    ccall((:ImfHeaderCompression, libOpenEXR), Cint, (Ptr{ImfHeader},), hdr)
end

function ImfHeaderSetIntAttribute(hdr, name, value)
    ccall((:ImfHeaderSetIntAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Cint), hdr, name, value)
end

function ImfHeaderIntAttribute(hdr, name, value)
    ccall((:ImfHeaderIntAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cint}), hdr, name, value)
end

function ImfHeaderSetFloatAttribute(hdr, name, value)
    ccall((:ImfHeaderSetFloatAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Cfloat), hdr, name, value)
end

function ImfHeaderSetDoubleAttribute(hdr, name, value)
    ccall((:ImfHeaderSetDoubleAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Cdouble), hdr, name, value)
end

function ImfHeaderFloatAttribute(hdr, name, value)
    ccall((:ImfHeaderFloatAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cfloat}), hdr, name, value)
end

function ImfHeaderDoubleAttribute(hdr, name, value)
    ccall((:ImfHeaderDoubleAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cdouble}), hdr, name, value)
end

function ImfHeaderSetStringAttribute(hdr, name, value)
    ccall((:ImfHeaderSetStringAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{UInt8}), hdr, name, value)
end

function ImfHeaderStringAttribute(hdr, name, value)
    ccall((:ImfHeaderStringAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cstring}), hdr, name, value)
end

function ImfHeaderSetBox2iAttribute(hdr, name, xMin, yMin, xMax, yMax)
    ccall((:ImfHeaderSetBox2iAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Cint, Cint, Cint, Cint), hdr, name, xMin, yMin, xMax, yMax)
end

function ImfHeaderBox2iAttribute(hdr, name, xMin, yMin, xMax, yMax)
    ccall((:ImfHeaderBox2iAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}), hdr, name, xMin, yMin, xMax, yMax)
end

function ImfHeaderSetBox2fAttribute(hdr, name, xMin, yMin, xMax, yMax)
    ccall((:ImfHeaderSetBox2fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Cfloat, Cfloat, Cfloat, Cfloat), hdr, name, xMin, yMin, xMax, yMax)
end

function ImfHeaderBox2fAttribute(hdr, name, xMin, yMin, xMax, yMax)
    ccall((:ImfHeaderBox2fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cfloat}, Ptr{Cfloat}, Ptr{Cfloat}, Ptr{Cfloat}), hdr, name, xMin, yMin, xMax, yMax)
end

function ImfHeaderSetV2iAttribute(hdr, name, x, y)
    ccall((:ImfHeaderSetV2iAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Cint, Cint), hdr, name, x, y)
end

function ImfHeaderV2iAttribute(hdr, name, x, y)
    ccall((:ImfHeaderV2iAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cint}, Ptr{Cint}), hdr, name, x, y)
end

function ImfHeaderSetV2fAttribute(hdr, name, x, y)
    ccall((:ImfHeaderSetV2fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Cfloat, Cfloat), hdr, name, x, y)
end

function ImfHeaderV2fAttribute(hdr, name, x, y)
    ccall((:ImfHeaderV2fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cfloat}, Ptr{Cfloat}), hdr, name, x, y)
end

function ImfHeaderSetV3iAttribute(hdr, name, x, y, z)
    ccall((:ImfHeaderSetV3iAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Cint, Cint, Cint), hdr, name, x, y, z)
end

function ImfHeaderV3iAttribute(hdr, name, x, y, z)
    ccall((:ImfHeaderV3iAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}), hdr, name, x, y, z)
end

function ImfHeaderSetV3fAttribute(hdr, name, x, y, z)
    ccall((:ImfHeaderSetV3fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Cfloat, Cfloat, Cfloat), hdr, name, x, y, z)
end

function ImfHeaderV3fAttribute(hdr, name, x, y, z)
    ccall((:ImfHeaderV3fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{Cfloat}, Ptr{Cfloat}, Ptr{Cfloat}), hdr, name, x, y, z)
end

function ImfHeaderSetM33fAttribute(hdr, name, m)
    ccall((:ImfHeaderSetM33fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{NTuple{3, Cfloat}}), hdr, name, m)
end

function ImfHeaderM33fAttribute(hdr, name, m)
    ccall((:ImfHeaderM33fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{NTuple{3, Cfloat}}), hdr, name, m)
end

function ImfHeaderSetM44fAttribute(hdr, name, m)
    ccall((:ImfHeaderSetM44fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{NTuple{4, Cfloat}}), hdr, name, m)
end

function ImfHeaderM44fAttribute(hdr, name, m)
    ccall((:ImfHeaderM44fAttribute, libOpenEXR), Cint, (Ptr{ImfHeader}, Ptr{UInt8}, Ptr{NTuple{4, Cfloat}}), hdr, name, m)
end

function ImfOpenOutputFile(name, hdr, channels)
    ccall((:ImfOpenOutputFile, libOpenEXR), Ptr{ImfOutputFile}, (Ptr{UInt8}, Ptr{ImfHeader}, Cint), name, hdr, channels)
end

function ImfCloseOutputFile(out)
    ccall((:ImfCloseOutputFile, libOpenEXR), Cint, (Ptr{ImfOutputFile},), out)
end

function ImfOutputSetFrameBuffer(out, base, xStride, yStride)
    ccall((:ImfOutputSetFrameBuffer, libOpenEXR), Cint, (Ptr{ImfOutputFile}, Ptr{ImfRgba}, Csize_t, Csize_t), out, base, xStride, yStride)
end

function ImfOutputWritePixels(out, numScanLines)
    ccall((:ImfOutputWritePixels, libOpenEXR), Cint, (Ptr{ImfOutputFile}, Cint), out, numScanLines)
end

function ImfOutputCurrentScanLine(out)
    ccall((:ImfOutputCurrentScanLine, libOpenEXR), Cint, (Ptr{ImfOutputFile},), out)
end

function ImfOutputHeader(out)
    ccall((:ImfOutputHeader, libOpenEXR), Ptr{ImfHeader}, (Ptr{ImfOutputFile},), out)
end

function ImfOutputChannels(out)
    ccall((:ImfOutputChannels, libOpenEXR), Cint, (Ptr{ImfOutputFile},), out)
end

function ImfOpenTiledOutputFile(name, hdr, channels, xSize, ySize, mode, rmode)
    ccall((:ImfOpenTiledOutputFile, libOpenEXR), Ptr{ImfTiledOutputFile}, (Ptr{UInt8}, Ptr{ImfHeader}, Cint, Cint, Cint, Cint, Cint), name, hdr, channels, xSize, ySize, mode, rmode)
end

function ImfCloseTiledOutputFile(out)
    ccall((:ImfCloseTiledOutputFile, libOpenEXR), Cint, (Ptr{ImfTiledOutputFile},), out)
end

function ImfTiledOutputSetFrameBuffer(out, base, xStride, yStride)
    ccall((:ImfTiledOutputSetFrameBuffer, libOpenEXR), Cint, (Ptr{ImfTiledOutputFile}, Ptr{ImfRgba}, Csize_t, Csize_t), out, base, xStride, yStride)
end

function ImfTiledOutputWriteTile(out, dx, dy, lx, ly)
    ccall((:ImfTiledOutputWriteTile, libOpenEXR), Cint, (Ptr{ImfTiledOutputFile}, Cint, Cint, Cint, Cint), out, dx, dy, lx, ly)
end

function ImfTiledOutputWriteTiles(out, dxMin, dxMax, dyMin, dyMax, lx, ly)
    ccall((:ImfTiledOutputWriteTiles, libOpenEXR), Cint, (Ptr{ImfTiledOutputFile}, Cint, Cint, Cint, Cint, Cint, Cint), out, dxMin, dxMax, dyMin, dyMax, lx, ly)
end

function ImfTiledOutputHeader(out)
    ccall((:ImfTiledOutputHeader, libOpenEXR), Ptr{ImfHeader}, (Ptr{ImfTiledOutputFile},), out)
end

function ImfTiledOutputChannels(out)
    ccall((:ImfTiledOutputChannels, libOpenEXR), Cint, (Ptr{ImfTiledOutputFile},), out)
end

function ImfTiledOutputTileXSize(out)
    ccall((:ImfTiledOutputTileXSize, libOpenEXR), Cint, (Ptr{ImfTiledOutputFile},), out)
end

function ImfTiledOutputTileYSize(out)
    ccall((:ImfTiledOutputTileYSize, libOpenEXR), Cint, (Ptr{ImfTiledOutputFile},), out)
end

function ImfTiledOutputLevelMode(out)
    ccall((:ImfTiledOutputLevelMode, libOpenEXR), Cint, (Ptr{ImfTiledOutputFile},), out)
end

function ImfTiledOutputLevelRoundingMode(out)
    ccall((:ImfTiledOutputLevelRoundingMode, libOpenEXR), Cint, (Ptr{ImfTiledOutputFile},), out)
end

function ImfOpenInputFile(name)
    ccall((:ImfOpenInputFile, libOpenEXR), Ptr{ImfInputFile}, (Ptr{UInt8},), name)
end

function ImfCloseInputFile(in)
    ccall((:ImfCloseInputFile, libOpenEXR), Cint, (Ptr{ImfInputFile},), in)
end

function ImfInputSetFrameBuffer(in, base, xStride, yStride)
    ccall((:ImfInputSetFrameBuffer, libOpenEXR), Cint, (Ptr{ImfInputFile}, Ptr{ImfRgba}, Csize_t, Csize_t), in, base, xStride, yStride)
end

function ImfInputReadPixels(in, scanLine1, scanLine2)
    ccall((:ImfInputReadPixels, libOpenEXR), Cint, (Ptr{ImfInputFile}, Cint, Cint), in, scanLine1, scanLine2)
end

function ImfInputHeader(in)
    ccall((:ImfInputHeader, libOpenEXR), Ptr{ImfHeader}, (Ptr{ImfInputFile},), in)
end

function ImfInputChannels(in)
    ccall((:ImfInputChannels, libOpenEXR), Cint, (Ptr{ImfInputFile},), in)
end

function ImfInputFileName(in)
    ccall((:ImfInputFileName, libOpenEXR), Cstring, (Ptr{ImfInputFile},), in)
end

function ImfOpenTiledInputFile(name)
    ccall((:ImfOpenTiledInputFile, libOpenEXR), Ptr{ImfTiledInputFile}, (Ptr{UInt8},), name)
end

function ImfCloseTiledInputFile(in)
    ccall((:ImfCloseTiledInputFile, libOpenEXR), Cint, (Ptr{ImfTiledInputFile},), in)
end

function ImfTiledInputSetFrameBuffer(in, base, xStride, yStride)
    ccall((:ImfTiledInputSetFrameBuffer, libOpenEXR), Cint, (Ptr{ImfTiledInputFile}, Ptr{ImfRgba}, Csize_t, Csize_t), in, base, xStride, yStride)
end

function ImfTiledInputReadTile(in, dx, dy, lx, ly)
    ccall((:ImfTiledInputReadTile, libOpenEXR), Cint, (Ptr{ImfTiledInputFile}, Cint, Cint, Cint, Cint), in, dx, dy, lx, ly)
end

function ImfTiledInputReadTiles(in, dxMin, dxMax, dyMin, dyMax, lx, ly)
    ccall((:ImfTiledInputReadTiles, libOpenEXR), Cint, (Ptr{ImfTiledInputFile}, Cint, Cint, Cint, Cint, Cint, Cint), in, dxMin, dxMax, dyMin, dyMax, lx, ly)
end

function ImfTiledInputHeader(in)
    ccall((:ImfTiledInputHeader, libOpenEXR), Ptr{ImfHeader}, (Ptr{ImfTiledInputFile},), in)
end

function ImfTiledInputChannels(in)
    ccall((:ImfTiledInputChannels, libOpenEXR), Cint, (Ptr{ImfTiledInputFile},), in)
end

function ImfTiledInputFileName(in)
    ccall((:ImfTiledInputFileName, libOpenEXR), Cstring, (Ptr{ImfTiledInputFile},), in)
end

function ImfTiledInputTileXSize(in)
    ccall((:ImfTiledInputTileXSize, libOpenEXR), Cint, (Ptr{ImfTiledInputFile},), in)
end

function ImfTiledInputTileYSize(in)
    ccall((:ImfTiledInputTileYSize, libOpenEXR), Cint, (Ptr{ImfTiledInputFile},), in)
end

function ImfTiledInputLevelMode(in)
    ccall((:ImfTiledInputLevelMode, libOpenEXR), Cint, (Ptr{ImfTiledInputFile},), in)
end

function ImfTiledInputLevelRoundingMode(in)
    ccall((:ImfTiledInputLevelRoundingMode, libOpenEXR), Cint, (Ptr{ImfTiledInputFile},), in)
end

function ImfNewRound12logLut(channels)
    ccall((:ImfNewRound12logLut, libOpenEXR), Ptr{ImfLut}, (Cint,), channels)
end

function ImfNewRoundNBitLut(n, channels)
    ccall((:ImfNewRoundNBitLut, libOpenEXR), Ptr{ImfLut}, (UInt32, Cint), n, channels)
end

function ImfDeleteLut(lut)
    ccall((:ImfDeleteLut, libOpenEXR), Cvoid, (Ptr{ImfLut},), lut)
end

function ImfApplyLut(lut, data, nData, stride)
    ccall((:ImfApplyLut, libOpenEXR), Cvoid, (Ptr{ImfLut}, Ptr{ImfRgba}, Cint, Cint), lut, data, nData, stride)
end

function ImfErrorMessage()
    ccall((:ImfErrorMessage, libOpenEXR), Cstring, ())
end

using Test, OpenEXR, FileIO, Colors, FixedPointNumbers

# helpers for testing channelwise bit-depth truncation
function channelwise_max_diff(a::RGBA, b::RGBA)
    max(abs(a.r - b.r), abs(a.g - b.g), abs(a.b - b.b), abs(a.alpha - b.alpha))
end

function channelwise_max_diff(a::RGB, b::RGB)
    max(abs(a.r - b.r), abs(a.g - b.g), abs(a.b - b.b))
end

function channelwise_max_diff(a::GrayA, b::GrayA)
    max(abs(a.val - b.val), abs(a.alpha - b.alpha))
end

function channelwise_max_diff(a::Gray, b::Gray)
    abs(a.val - b.val)
end

@testset "RoundTrip" begin

    @testset "Identical" begin
        for typ in (RGBA{Float16}, RGB{Float16}, GrayA{Float16}, Gray{Float16})
            img = rand(typ, 256, 512)
            fn = File{DataFormat{:EXR}}(tempname())
            OpenEXR.save(fn, img)
            try
                loaded_img = OpenEXR.load(fn)
                @test typeof(loaded_img) === Array{typ,2}
                @test img == loaded_img
            finally
                rm(fn.filename)
            end
        end
    end

    @testset "Lossless with type conversion" begin
        for (save_type, load_type) in (
            (RGBA{N0f8}, RGBA{Float16}),
            (RGB{N0f8}, RGB{Float16}),
            (GrayA{N0f8}, GrayA{Float16}),
            (Gray{N0f8}, Gray{Float16}),
        )
            img = rand(save_type, 256, 512)
            fn = File{DataFormat{:EXR}}(tempname())
            OpenEXR.save(fn, img)
            try
                loaded_img = OpenEXR.load(fn)
                @test typeof(loaded_img) === Array{load_type,2}
                converted_img = (c -> convert(save_type, c)).(loaded_img)
                @test converted_img == img
            finally
                rm(fn.filename)
            end
        end
    end

    @testset "Lossy with type conversion" begin

        @testset "Bit depth truncation" begin
            for (save_type, load_type) in (
                (RGBA{Float32}, RGBA{Float16}),
                (RGB{Float32}, RGB{Float16}),
                (GrayA{Float32}, GrayA{Float16}),
                (Gray{Float32}, Gray{Float16}),
            )
                img = rand(save_type, 256, 512)
                fn = File{DataFormat{:EXR}}(tempname())
                OpenEXR.save(fn, img)
                try
                    loaded_img = OpenEXR.load(fn)

                    # return type is as expected
                    @test typeof(loaded_img) === Array{load_type,2}

                    # differences are bounded channelwise
                    diffs = map(channelwise_max_diff, img, loaded_img)
                    @test maximum(diffs) <= 2.5e-4
                finally
                    rm(fn.filename)
                end
            end
        end

        @testset "Colorspace conversion" begin
            for save_type in
                (HSV{Float16}, HSL{Float16}, Lab{Float16}, LCHab{Float16}, YIQ{Float16})
                img = rand(save_type, 256, 512)
                fn = File{DataFormat{:EXR}}(tempname())
                OpenEXR.save(fn, img)
                try
                    loaded_img = OpenEXR.load(fn)

                    # return type is as expected
                    @test typeof(loaded_img) === Array{RGB{Float16},2}

                    # differences are bounded channelwise
                    converted_img = (c -> convert(RGB{Float16}, c)).(img)
                    diffs = map(channelwise_max_diff, converted_img, loaded_img)
                    @test maximum(diffs) <= 2.5e-4
                finally
                    rm(fn.filename)
                end
            end
        end
    end
end

# Automatically generated using Clang.jl


const IMF_MAGIC = 20000630
const IMF_VERSION_NUMBER = 2
const IMF_INCREASING_Y = 0
const IMF_DECREASING_Y = 1
const IMF_RANDOM_Y = 2
const IMF_NO_COMPRESSION = 0
const IMF_RLE_COMPRESSION = 1
const IMF_ZIPS_COMPRESSION = 2
const IMF_ZIP_COMPRESSION = 3
const IMF_PIZ_COMPRESSION = 4
const IMF_PXR24_COMPRESSION = 5
const IMF_B44_COMPRESSION = 6
const IMF_B44A_COMPRESSION = 7
const IMF_DWAA_COMPRESSION = 8
const IMF_DWAB_COMPRESSION = 9
const IMF_WRITE_R = 0x01
const IMF_WRITE_G = 0x02
const IMF_WRITE_B = 0x04
const IMF_WRITE_A = 0x08
const IMF_WRITE_Y = 0x10
const IMF_WRITE_C = 0x20
const IMF_WRITE_RGB = 0x07
const IMF_WRITE_YC = 0x30
const IMF_WRITE_YA = 0x18
const IMF_WRITE_YCA = 0x38
const IMF_ONE_LEVEL = 0
const IMF_MIPMAP_LEVELS = 1
const IMF_RIPMAP_LEVELS = 2
const IMF_ROUND_DOWN = 0
const IMF_ROUND_UP = 1
const ImfHeader = Cvoid
const ImfOutputFile = Cvoid
const ImfTiledOutputFile = Cvoid
const ImfInputFile = Cvoid
const ImfTiledInputFile = Cvoid
const ImfLut = Cvoid

module OpenEXR

export load_exr, save_exr

using FileIO, Colors

module C
using OpenEXR_jll
using Colors
const ImfHalf = Float16
const ImfRgba = RGBA{ImfHalf}
include("OpenEXR_common.jl")
include("OpenEXR_api.jl")
const IMF_WRITE_RGBA = IMF_WRITE_RGB + IMF_WRITE_A
end  # module C

const MAGIC = Cint(C.IMF_MAGIC)

@enum Compression::Cint begin
    NO_COMPRESSION = C.IMF_NO_COMPRESSION
    RLE_COMPRESSION = C.IMF_RLE_COMPRESSION
    ZIPS_COMPRESSION = C.IMF_ZIPS_COMPRESSION
    ZIP_COMPRESSION = C.IMF_ZIP_COMPRESSION
    PIZ_COMPRESSION = C.IMF_PIZ_COMPRESSION
    PXR24_COMPRESSION = C.IMF_PXR24_COMPRESSION
    B44_COMPRESSION = C.IMF_B44_COMPRESSION
    B44A_COMPRESSION = C.IMF_B44A_COMPRESSION
    DWAA_COMPRESSION = C.IMF_DWAA_COMPRESSION
    DWAB_COMPRESSION = C.IMF_DWAB_COMPRESSION
end

@enum RgbaChannels::Cint begin
    WRITE_R = C.IMF_WRITE_R
    WRITE_G = C.IMF_WRITE_G
    WRITE_B = C.IMF_WRITE_B
    WRITE_A = C.IMF_WRITE_A
    WRITE_Y = C.IMF_WRITE_Y
    WRITE_C = C.IMF_WRITE_C
    WRITE_RGB = C.IMF_WRITE_RGB
    WRITE_RGBA = C.IMF_WRITE_RGBA
    WRITE_YC = C.IMF_WRITE_YC
    WRITE_YA = C.IMF_WRITE_YA
    WRITE_YCA = C.IMF_WRITE_YCA
end

function check(ret)
    ret == typeof(ret)(0) && error(unsafe_string(C.ImfErrorMessage()))
end

"""
    load_exr(filename)::(Array{RGBA{Float16},2}, RgbaChannels)

Returns the image data contained in `filename` along with flags representing the on-disk
storage format.
"""
function load_exr(filename)
    infile = C.ImfOpenInputFile(filename)  # open the file
    check(infile)
    chans = RgbaChannels(C.ImfInputChannels(infile))
    try
        # get the header
        hdr = C.ImfInputHeader(infile)

        # read its data window
        xmin = Ref{Cint}()
        ymin = Ref{Cint}()
        xmax = Ref{Cint}()
        ymax = Ref{Cint}()
        C.ImfHeaderDataWindow(hdr, xmin, ymin, xmax, ymax)

        # compute the window size
        width = xmax[] - xmin[] + 1
        height = ymax[] - ymin[] + 1

        # allocate space for the result and get its strides
        data = Array{C.ImfRgba,2}(undef, height, width)
        (xstride, ystride) = strides(data)

        # get the pointer to the data, shifting it according to the expected window
        dataptr =
            Base.unsafe_convert(Ptr{C.ImfRgba}, data) - xmin[] * xstride - ymin[] * ystride

        # copy the data
        check(C.ImfInputSetFrameBuffer(infile, dataptr, ystride, xstride))
        check(C.ImfInputReadPixels(infile, ymin[], ymax[]))

        # return the loaded raster along with the channels
        return (data, chans)
    finally
        check(C.ImfCloseInputFile(infile))
    end
end

"""
    save_exr(filename, image[, compression[, channels]])

Save `image` as an OpenEXR file in `filename`, storing the data in a format
indicated by `channels` using the `compression` algorithm.
"""
function save_exr(
    filename,
    image::AbstractArray{C.ImfRgba,2},
    compression::Compression = ZIP_COMPRESSION,
    channels::RgbaChannels = WRITE_RGBA,
)
    # get the size of the data
    (height, width) = size(image)

    # create a new header
    hdr = C.ImfNewHeader()
    check(hdr)
    try
        # set the compression
        C.ImfHeaderSetCompression(hdr, compression)

        # set the correct window sizes
        C.ImfHeaderSetDataWindow(hdr, 0, 0, width - 1, height - 1)
        C.ImfHeaderSetDisplayWindow(hdr, 0, 0, width - 1, height - 1)

        # open the output file
        outfile = C.ImfOpenOutputFile(filename, hdr, channels)
        check(outfile)
        try
            # get the strides and a pointer to the raster
            (xstride, ystride) = strides(image)
            dataptr = Base.unsafe_convert(Ptr{C.ImfRgba}, image)

            # copy the data
            check(C.ImfOutputSetFrameBuffer(outfile, dataptr, ystride, xstride))
            check(C.ImfOutputWritePixels(outfile, height))
        finally
            check(C.ImfCloseOutputFile(outfile))
        end
    finally
        C.ImfDeleteHeader(hdr)
    end
    nothing
end

function save_exr(
    filename,
    image::AbstractArray{T,2},
    compression::Compression = ZIP_COMPRESSION,
    channels::RgbaChannels = WRITE_RGBA,
) where {T}
    save_exr(filename, (c -> convert(C.ImfRgba, c)).(image), compression, channels)
end

"""
    load(filename)::Array{[RGB|RGBA|Gray|GrayA]{Float16},2}

Returns the image data contained in `filename`.
"""
function load(filename::AbstractString)
    (rgba, chans) = load_exr(filename)
    if chans == WRITE_YA
        return (c -> convert(GrayA{Float16}, c)).(rgba)
    elseif chans == WRITE_Y
        return (c -> convert(Gray{Float16}, c)).(rgba)
    elseif UInt32(chans) & UInt32(WRITE_A) == 0x00
        return (c -> convert(RGB{Float16}, c)).(rgba)
    else
        return rgba
    end
end

"""
    save(filename, image[, compression])

Save `image` as an OpenEXR file in `filename` using the `compression` algorithm.
"""
function save(
    filename::AbstractString,
    image::AbstractArray{T,2},
    compression::Compression = ZIP_COMPRESSION,
) where {T<:Transparent3}
    save_exr(filename, image, compression, WRITE_RGBA)
end

function save(
    filename::AbstractString,
    image::AbstractArray{T,2},
    compression::Compression = ZIP_COMPRESSION,
) where {T<:Color3}
    save_exr(filename, image, compression, WRITE_RGB)
end

function save(
    filename::AbstractString,
    image::AbstractArray{T,2},
    compression::Compression = ZIP_COMPRESSION,
) where {T<:TransparentGray}
    save_exr(filename, image, compression, WRITE_YA)
end

function save(
    filename::AbstractString,
    image::AbstractArray{T,2},
    compression::Compression = ZIP_COMPRESSION,
) where {T<:AbstractGray}
    save_exr(filename, image, compression, WRITE_Y)
end

# FileIO interface
load(f::File{DataFormat{:EXR}}, args...) = load(f.filename, args...)
save(f::File{DataFormat{:EXR}}, args...) = save(f.filename, args...)

end  # module OpenEXR

using Clang
using OpenEXR_jll

const OPENEXR_INCLUDE = joinpath(OpenEXR_jll.artifact_dir, "include", "OpenEXR") |> normpath
const OPENEXR_HEADERS = [joinpath(OPENEXR_INCLUDE, "ImfCRgbaFile.h")]

# create a work context
ctx = DefaultContext()

# parse headers
parse_headers!(ctx, OPENEXR_HEADERS,
               args=["-I", joinpath(OPENEXR_INCLUDE, "..")],
               includes=vcat(OPENEXR_INCLUDE, CLANG_INCLUDE),
               )

# settings
ctx.libname = "libOpenEXR"
ctx.options["is_function_strictly_typed"] = false
ctx.options["is_struct_mutable"] = false

# write output
api_file = joinpath(@__DIR__, "..", "src", "OpenEXR_api.jl")
api_stream = open(api_file, "w")

for trans_unit in ctx.trans_units
    root_cursor = getcursor(trans_unit)
    push!(ctx.cursor_stack, root_cursor)
    header = spelling(root_cursor)
    @info "wrapping header: $header ..."
    # loop over all of the child cursors and wrap them, if appropriate.
    ctx.children = children(root_cursor)
    for (i, child) in enumerate(ctx.children)
        child_name = name(child)
        child_header = filename(child)
        ctx.children_index = i
        # choose which cursor to wrap
        startswith(child_name, "__") && continue  # skip compiler definitions
        child_name in keys(ctx.common_buffer) && continue  # already wrapped
        child_header != header && continue  # skip if cursor filename is not in the headers to be wrapped

        wrap!(ctx, child)
    end
    @info "writing $(api_file)"
    println(api_stream, "# Julia wrapper for header: $(basename(header))")
    println(api_stream, "# Automatically generated using Clang.jl\n")
    print_buffer(api_stream, ctx.api_buffer)
    empty!(ctx.api_buffer)  # clean up api_buffer for the next header
end
close(api_stream)

# Remove definition of ImfHalf. We will define it as Float16 instead of UInt16.
pop!(ctx.common_buffer, :ImfHalf)

# Remove definition of ImfRgba. We will define it as RGBA{ImfHalf}.
pop!(ctx.common_buffer, :ImfRgba)

# Remove definition of IMF_WRITE_RGBA. It isn't correct.
pop!(ctx.common_buffer, :IMF_WRITE_RGBA)

# Write "common" definitions: types, typealiases, etc.
common_file = joinpath(@__DIR__, "..", "src", "OpenEXR_common.jl")
open(common_file, "w") do f
    println(f, "# Automatically generated using Clang.jl\n")
    print_buffer(f, dump_to_buffer(ctx.common_buffer))
end
